Index: sasmodels/direct_model.py
===================================================================
--- sasmodels/direct_model.py	(revision d1ff3a5d39af7e61166a61d76c48aa3a86a6e216)
+++ sasmodels/direct_model.py	(revision d1ff3a5d39af7e61166a61d76c48aa3a86a6e216)
@@ -202,14 +202,21 @@
 
         if self.data_type == 'sesans':
-            q = sesans.make_q(data.sample.zacceptance, data.Rmax)
-            index = slice(None, None)
-            res = None
-            if data.y is not None:
-                Iq, dIq = data.y, data.dy
+            from sas.sascalc.data_util.nxsunit import Converter
+            qmax, qunits = data.sample.zacceptance
+            SElength = Converter(data._xunit)(data.x, "A")
+            zaccept = Converter(qunits)(qmax, "1/A"),
+            Rmax = 10000000
+            index = slice(None, None)  # equivalent to index [:]
+            Iq = data.y[index]
+            dIq = data.dy[index]
+            oriented = getattr(data, 'oriented', False)
+            if oriented:
+                res = sesans.OrientedSesansTransform(data.x[index], SElength, zaccept, Rmax)
+                # Oriented sesans transform produces q_calc = [qx, qy]
+                q_vectors = res.q_calc
             else:
-                Iq, dIq = None, None
-            #self._theory = np.zeros_like(q)
-            q_vectors = [q]
-            q_mono = sesans.make_all_q(data)
+                res = sesans.SesansTransform(data.x[index], SElength, zaccept, Rmax)
+                # Unoriented sesans transform produces q_calc = q
+                q_vectors = [res.q_calc]
         elif self.data_type == 'Iqxy':
             #if not model.info.parameters.has_2d:
@@ -230,5 +237,4 @@
             #self._theory = np.zeros_like(self.Iq)
             q_vectors = res.q_calc
-            q_mono = []
         elif self.data_type == 'Iq':
             index = (data.x >= data.qmin) & (data.x <= data.qmax)
@@ -255,5 +261,4 @@
             #self._theory = np.zeros_like(self.Iq)
             q_vectors = [res.q_calc]
-            q_mono = []
         elif self.data_type == 'Iq-oriented':
             index = (data.x >= data.qmin) & (data.x <= data.qmax)
@@ -272,5 +277,4 @@
                                       qy_width=data.dxl[index])
             q_vectors = res.q_calc
-            q_mono = []
         else:
             raise ValueError("Unknown data type") # never gets here
@@ -279,5 +283,4 @@
         # so we can save/restore state
         self._kernel_inputs = q_vectors
-        self._kernel_mono_inputs = q_mono
         self._kernel = None
         self.Iq, self.dIq, self.index = Iq, dIq, index
@@ -317,7 +320,4 @@
         if self._kernel is None:
             self._kernel = self._model.make_kernel(self._kernel_inputs)
-            self._kernel_mono = (
-                self._model.make_kernel(self._kernel_mono_inputs)
-                if self._kernel_mono_inputs else None)
 
         Iq_calc = call_kernel(self._kernel, pars, cutoff=cutoff)
@@ -326,18 +326,11 @@
         # TODO: extend plotting of calculate Iq to other measurement types
         # TODO: refactor so we don't store the result in the model
-        self.Iq_calc = Iq_calc
-        if self.data_type == 'sesans':
-            Iq_mono = (call_kernel(self._kernel_mono, pars, mono=True)
-                       if self._kernel_mono_inputs else None)
-            result = sesans.transform(self._data,
-                                      self._kernel_inputs[0], Iq_calc,
-                                      self._kernel_mono_inputs, Iq_mono)
-        else:
-            result = self.resolution.apply(Iq_calc)
-            if hasattr(self.resolution, 'nx'):
-                self.Iq_calc = (
-                    self.resolution.qx_calc, self.resolution.qy_calc,
-                    np.reshape(Iq_calc, (self.resolution.ny, self.resolution.nx))
-                )
+        self.Iq_calc = None
+        result = self.resolution.apply(Iq_calc)
+        if hasattr(self.resolution, 'nx'):
+            self.Iq_calc = (
+                self.resolution.qx_calc, self.resolution.qy_calc,
+                np.reshape(Iq_calc, (self.resolution.ny, self.resolution.nx))
+            )
         return result
 
